package com.zcloud.zcGbsServicer.persistence.repository.impl;

import com.alibaba.cola.dto.PageResponse;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.jjb.saas.framework.repository.common.PageHelper;
import com.jjb.saas.framework.repository.repo.impl.BaseRepositoryImpl;
import com.zcloud.gbscommon.utils.PageQueryHelper;
import com.zcloud.gbscommon.utils.Query;
import com.zcloud.zcGbsServicer.persistence.dataobject.WaterSourceDO;
import com.zcloud.zcGbsServicer.persistence.mapper.WaterSourceMapper;
import com.zcloud.zcGbsServicer.persistence.repository.WaterSourceRepository;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;

import java.util.Map;

/**
* web-infrastructure
* @Author makejava
* @Date 2026-01-21 17:23:50
*/
@Service
@RequiredArgsConstructor
public class WaterSourceRepositoryImpl extends BaseRepositoryImpl<WaterSourceMapper, WaterSourceDO> implements WaterSourceRepository {
    private final WaterSourceMapper waterSourceMapper;

    @Override
    public PageResponse<WaterSourceDO> listPage(Map<String, Object> params) {
        IPage<WaterSourceDO> iPage = new Query<WaterSourceDO>().getPage(params);
        QueryWrapper<WaterSourceDO> queryWrapper = new QueryWrapper<>();
        Object corpId = params == null ? null : params.remove("eqCorpId");
        String menuPerms = params == null ? null : (String) params.remove("menuPerms");
        queryWrapper = PageQueryHelper.createPageQueryWrapper(queryWrapper, params);
        if (corpId != null) {
            queryWrapper.eq("tenant_id", corpId);
        }
        IPage<WaterSourceDO> result = waterSourceMapper.selectPageSql(iPage, queryWrapper, menuPerms);
        return PageHelper.pageToResponse(result, result.getRecords());
    }

    @Override
    public PageResponse<WaterSourceDO> listScreen(IPage<WaterSourceDO> page, Map<String, Object> params) {
        IPage<WaterSourceDO> result = waterSourceMapper.selectScreenList(page, params);
        return PageHelper.pageToResponse(result, result.getRecords());
    }
}
